Index: bc/bc.y
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/bc/bc.y,v
retrieving revision 1.1.1.2
diff -u -p -r1.1.1.2 bc.y
--- bc/bc.y	26 Feb 2001 07:12:53 -0000	1.1.1.2
+++ bc/bc.y	9 Jul 2003 13:26:35 -0000
@@ -107,11 +107,6 @@
 program			: /* empty */
 			    {
 			      $$ = 0;
-			      if (interactive && !quiet)
-				{
-				  show_bc_version ();
-				  welcome ();
-				}
 			    }
 			| program input_item
 			;
Index: bc/global.h
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/bc/global.h,v
retrieving revision 1.1.1.1
diff -u -p -r1.1.1.1 global.h
--- bc/global.h	26 Feb 2001 07:12:55 -0000	1.1.1.1
+++ bc/global.h	9 Jul 2003 13:31:44 -0000
@@ -66,9 +66,6 @@ EXTERN int warn_not_std;
 /* Accept POSIX bc only!  -s flag. */
 EXTERN int std_only;
 
-/* Don't print the banner at start up.  -q flag. */
-EXTERN int quiet;
-
 /* The list of file names to process. */
 EXTERN file_node *file_names;
 
Index: bc/main.c
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/bc/main.c,v
retrieving revision 1.5
diff -u -p -r1.5 main.c
--- bc/main.c	26 Feb 2001 07:17:00 -0000	1.5
+++ bc/main.c	9 Jul 2003 13:31:31 -0000
@@ -50,7 +50,6 @@ static struct option long_options[] =
   {"help",     0, 0,             'h'},
   {"interactive", 0, 0,          'i'},
   {"mathlib",  0, &use_math,     TRUE},
-  {"quiet",    0, &quiet,        TRUE},
   {"standard", 0, &std_only,     TRUE},
   {"version",  0, 0,             'v'},
   {"warn",     0, &warn_not_std, TRUE},
@@ -66,7 +65,6 @@ usage (char *progname)
           "  -h  --help         print this usage and exit\n",
 	  "  -i  --interactive  force interactive mode\n",
 	  "  -l  --mathlib      use the predefine math routnes\n",
-	  "  -q  --quiet        don't print initial banner\n",
 	  "  -s  --standard     non-standard bc constructs are errors\n",
 	  "  -w  --warn         warn about non-standard bc constructs\n",
 	  "  -v  --version      print version information and exit\n");
@@ -88,7 +86,7 @@ parse_args (argc, argv)
   /* Parse the command line */
   while (1)
     {
-      optch = getopt_long (argc, argv, "chilqswv", long_options, &long_index);
+      optch = getopt_long (argc, argv, "chilswv", long_options, &long_index);
 
       if (optch == EOF)  /* End of arguments. */
 	break;
@@ -112,10 +110,6 @@ parse_args (argc, argv)
 	  use_math = TRUE;
 	  break;
 
-	case 'q':  /* quiet mode */
-	  quiet = TRUE;
-	  break;
-
 	case 's':  /* Non standard features give errors. */
 	  std_only = TRUE;
 	  break;
@@ -169,7 +163,6 @@ main (argc, argv)
     interactive = TRUE;
   else
     interactive = FALSE;
-  quiet = FALSE;
   file_names = NULL;
 
 #ifdef HAVE_SETVBUF
Index: bc/sbc.y
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/bc/sbc.y,v
retrieving revision 1.1.1.2
diff -u -p -r1.1.1.2 sbc.y
--- bc/sbc.y	26 Feb 2001 07:12:55 -0000	1.1.1.2
+++ bc/sbc.y	9 Jul 2003 13:26:43 -0000
@@ -82,11 +82,6 @@ program			: /* empty */
 			    {
 			      $$ = 0;
 			      std_only = TRUE;
-			      if (interactive)
-				{
-				  printf ("s%s\n", BC_VERSION);
-				  welcome();
-				}
 			    }
 			| program input_item
 			;
Index: bc/util.c
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/bc/util.c,v
retrieving revision 1.1.1.2
diff -u -p -r1.1.1.2 util.c
--- bc/util.c	26 Feb 2001 07:12:54 -0000	1.1.1.2
+++ bc/util.c	9 Jul 2003 13:26:18 -0000
@@ -628,16 +628,6 @@ lookup (name, namekind)
   /* not reached */
 }
 
-
-/* Print the welcome banner. */
-
-void 
-welcome()
-{
-  printf ("This is free software with ABSOLUTELY NO WARRANTY.\n");
-  printf ("For details type `warranty'. \n");
-}
-
 /* Print out the version information. */
 void
 show_bc_version()
Index: doc/bc.1
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/doc/bc.1,v
retrieving revision 1.6
diff -u -p -r1.6 bc.1
--- doc/bc.1	12 Jul 2001 07:35:06 -0000	1.6
+++ doc/bc.1	9 Jul 2003 13:32:16 -0000
@@ -65,8 +65,6 @@ Define the standard math library.
 Give warnings for extensions to POSIX \fBbc\fR.
 .IP "-s, --standard"
 Process exactly the POSIX \fBbc\fR language.
-.IP "-q, --quiet"
-Do not print the normal GNU bc welcome.
 .IP "-v, --version"
 Print the version number and copyright and quit.
 .SS NUMBERS
Index: doc/bc.texi
===================================================================
RCS file: /space2/ncvs/src/contrib/bc/doc/bc.texi,v
retrieving revision 1.1.1.1
diff -u -p -r1.1.1.1 bc.texi
--- doc/bc.texi	26 Feb 2001 07:12:57 -0000	1.1.1.1
+++ doc/bc.texi	9 Jul 2003 13:32:29 -0000
@@ -128,9 +128,6 @@ Give warnings for extensions to POSIX @c
 @item -s, --standard
 Process exactly the POSIX @command{bc} language.
 
-@item -q, --quiet
-Do not print the normal GNU @command{bc} welcome.
-
 @item -v, --version 
 Print the version number and copyright and quit.
 